
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdio.h>
#include <avr/delay.h>
#include <avr/pgmspace.h>
#include <stdlib.h>

#include "uart.h"
#define XTAL_CPU			7372800
#define UART_BAUD_RATE      9600    // 9600 baud *


#define SPI_OFF		SPCR &= ~(1<<SPE)
#define	SPI_ON		SPCR |= (1<<SPE)


volatile unsigned char spi_data[128];
volatile unsigned char cnt;
volatile unsigned char rs;





void SPI_sinit(void)
{
	PORTB = 0xFF;		// Pull Up's on
	SPCR = (1<<SPE)|(1<<CPHA)|(1<<CPOL);	// SPI enable
}


unsigned char SPI_SlaveReceive(void)
{
	/* Wait for reception complete */
	while(!(SPSR & (1<<SPIF)));
	/* Return data register */
	return SPDR;
}


//Routine fr printf
int usart_putchar (char c)
{
	if (c == '\n')
		usart_putchar('\r');
	//Warten solange bis Zeichen gesendet wurde
	loop_until_bit_is_set(UCSRA, UDRE);
	UDR = c;
	return (0);
}





	


int main(void)
{
	uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,XTAL_CPU) );	// UART INIT 
	SPI_sinit();
	sei();
	//ffnet einen kanal fr printf
	fdevopen (usart_putchar, NULL, 0);
	printf("Start Triggering\n");
	for(;;)
	{
				


				for(cnt=0;cnt<128;cnt++)
				{
					SPI_SlaveReceive();
					spi_data[cnt] = SPDR;
					SPDR = 0;
				}
				
				for(cnt=0;cnt<128;cnt++)
				{
					printf("Byte Nr.%d: ",cnt);
					printf("0x%02X",spi_data[cnt]);
					printf("\n");
				}
	}
}

